Bug 85940 - Accessing paragraph and character styles from context menu
Summary: Accessing paragraph and character styles from context menu
Status: ASSIGNED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: LibreOffice (show other bugs)
Version:
(earliest affected)
Inherited From OOo
Hardware: Other All
: medium enhancement
Assignee: Yousuf Philips (jay)
QA Contact:
URL:
Whiteboard: target:6.0.0 target:5.4.0.1
Keywords:
Depends on: 108752
Blocks: Context-Menu Writer-Styles Writer-Styles-Paragraph Writer-Styles-Character
  Show dependency treegraph
 
Reported: 2014-11-05 20:43 UTC by Yousuf Philips (jay)
Modified: 2017-07-23 22:34 UTC (History)
6 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Yousuf Philips (jay) 2014-11-05 20:43:57 UTC
With the removal of direct formatting options from the context menu in bug 81132 and the importance of promoting the use of styles in document creation, i'd like to suggest we add style submenus for applied and custom paragraph and character styles. One advantage of this is that character styles are not available in the style drop down in the toolbar.
Comment 1 Cor Nouws 2014-11-18 22:36:57 UTC
I've seen this before and am a bit undecided.
Don't the context menus become too large?
The subemnues themselves can also grow too larger?

Just not sure. In the end we cannot push all in each menu and still expect people to easily find stuff :)

(hmm I should get me a recent daily to look how it is now :) )
Comment 2 Yousuf Philips (jay) 2014-11-19 00:38:51 UTC
(In reply to Cor Nouws from comment #1)
> I've seen this before and am a bit undecided.
> Don't the context menus become too large?

We did eliminated 3 direct formatting submenu entries from the context in bug 81132.

> The subemnues themselves can also grow too larger?

Nothing could be larger that the previous font names submenu. ;D

> Just not sure. In the end we cannot push all in each menu and still expect
> people to easily find stuff :)

Well as the description mentioned, its primarily for applied and custom styles. This would work great for paragraph styles, but charcter styles would need a default list in addition to the applied and custom styles, similar to whats is found in the toolbar style drop down list. These default character styles would be for Emphasis, Quotation, Strong Emphasis, Source Text, Internet Link, etc.

> (hmm I should get me a recent daily to look how it is now :) )

Yes you should definitely get one. ;D

I think putting it in the context menu will also bring more awareness and usage of styles.
Comment 3 Yousuf Philips (jay) 2014-11-23 05:20:14 UTC
Was reading through the removal of direct formatting entries from the context menu bug 81132 and noticed that this same idea was suggested by Mirek:

On the topic of styles, it'd be nice to have a "Paragraph Styles"  and a "Character Styles" here.

And it was also recommended by Niklas Johansson:

But I also like to echo Mirek's suggestion ... Especially the part about Paragraph styles, preferably only a selection of styles like in the combo box in the formatting toolbar.
Comment 4 Robinson Tryon (qubit) 2014-12-21 22:32:24 UTC
UX: Another one for you :-)

Status -> NEW
Comment 5 Heiko Tietze 2016-05-24 12:20:25 UTC
If we introduce styles from the context menu it would be required for all types. I mean also table styles, which show up when you are in a table, as well as list and graphic style etc. And how about page style? Probably not since it's not context dependent.
Comment 6 Robinson Tryon (qubit) 2016-08-25 05:49:21 UTC
We're replacing our use of the 'ux-advise' component with a keyword:
 Component -> LibreOffice
 Add Keyword: needsUXEval

[NinjaEdit]
Comment 7 Yousuf Philips (jay) 2016-10-09 10:21:28 UTC
(In reply to Heiko Tietze from comment #5)
> If we introduce styles from the context menu it would be required for all
> types.

Dont really see a point of going beyond paragraph and character styles in the context menu, as the main object is to promote text styles, especially as there isnt any easy access to set character styles.
Comment 8 Heiko Tietze 2016-10-10 08:09:26 UTC
(In reply to Yousuf Philips (jay) from comment #7)
> Dont really see a point of going beyond paragraph and character styles...

You should adjust the title in this case. 

About the number of items (Cor's comment 1): we are talking often about user defined lists that easily grow to an unusable extend. The idea in general is to show a small number of preselected default options that are overridden by the user (first factory settings, second document properties, third current changes).
In case of paragraph styles it would be for instance [H1,H2,H3,Text,Citation] changed to [MyStyle1,H1,H2,H3,Text], [MyStyle2,MyStyle1,H1,H2,H3] etc. and the list is resorted when something is selected like [H2,MyStyle2,MyStyle1,H1,H3].
This type of "recently used properties" should be applied to all user lists.
Comment 9 Cor Nouws 2016-10-18 18:57:29 UTC
So the context menu would be

--------
Styles > Clear direct Formatting
         -----------------------
         Edit Style
         -----------------------
         Character Styles      >
         -----------------------
         Paragraph Styles      >

?
Comment 10 Yousuf Philips (jay) 2016-10-18 20:41:07 UTC
(In reply to Cor Nouws from comment #9)
> So the context menu would be
> 
> --------
> Styles > Clear direct Formatting

I'd put this at the bottom, but its up to you.

>          -----------------------
>          Edit Style
>          -----------------------
>          Character Styles      >
>          -----------------------
>          Paragraph Styles      >

As 'Edit Style' is editing paragraph style, i'd put those together

-----------------------
Edit Paragraph Style
Paragraph Styles      >
-----------------------
Character Styles      >
Comment 11 Yousuf Philips (jay) 2017-05-23 02:05:32 UTC
Patch is in to create the Styles submenu
https://gerrit.libreoffice.org/#/c/37925/

So the question is now, which paragraph and character styles should be added? When i filed this bug, the Styles menu didnt exist, which meant that paragraph styles were accessible through the formatting toolbar and sidebar and character styles were only accessible in the sidebar. For me, i see character styles to be the most important things to add to the context menu, to give more availability outside of the menubar.
Comment 12 Heiko Tietze 2017-05-23 06:47:03 UTC
(In reply to Yousuf Philips (jay) from comment #11)
> So the question is now, which paragraph and character styles should be
> added?

What's wrong with comment 5 and comment 9? Additionally to Paragraph and Character we need to add List now. Or do you want to select a few items out of the various character styles?
Comment 13 Yousuf Philips (jay) 2017-05-24 00:00:31 UTC
(In reply to Heiko Tietze from comment #12)
> What's wrong with comment 5 and comment 9? Additionally to Paragraph and
> Character we need to add List now. Or do you want to select a few items out
> of the various character styles?

Yes we dont want to overload the context menu with every single style found in the Style menu. We should select useful and highly used styles worth putting in it to provide easy access that isnt easily accessible, which presently is just character styles. Once we have a good set of default list styles (bug 106988), a few of those would also be useful to include, though i'm not sure how used list styles are at all with how bad the current defaults are.
Comment 14 Yousuf Philips (jay) 2017-05-25 00:28:22 UTC
Any suggestions which builtin character styles are most used. My thoughts are the following, as they are added to the styles formatting toolbar (bug 106781).

Emphasis        (aka Italics)
Strong Emphasis (aka Bold)
Source Text     (aka Code)
Comment 15 Thomas Lendo 2017-05-25 05:52:02 UTC
And "Default" to revert character styles.
Comment 16 Thomas Lendo 2017-06-10 09:43:02 UTC
I wouldn't use sub-submenus for styles, it causes complicated and long mouse ways. Will someone use it in that way? I would suggest so have paragraph and character submenus in the main context menu level instead. People don't care of "styles", they want use paragraph formatting or word formatting or list formatting therefore a "Styles" submenus is not optimal.

Additionally I would suggest to use no fixed styles lists for paragraphs and characters but a similar automatic list like in bug 108030.
Comment 17 Yousuf Philips (jay) 2017-06-10 12:29:46 UTC
(In reply to Thomas Lendo from comment #16)
> I wouldn't use sub-submenus for styles, it causes complicated and long mouse
> ways. Will someone use it in that way?

Yes the intent now is not to use sub-submenus, but to have them listed in the styles submenu. Yes people who want to access styles will use it this way.

> I would suggest so have paragraph and
> character submenus in the main context menu level instead. People don't care
> of "styles", they want use paragraph formatting or word formatting or list
> formatting therefore a "Styles" submenus is not optimal.

Didnt quite follow this and style users care about styles.

> Additionally I would suggest to use no fixed styles lists for paragraphs and
> characters but a similar automatic list like in bug 108030.

Presently having a non-fixed style list requires dev work, so once the necessary UNO command is created for it (bug 101896), this would be possible if the list can be filtered by the styles that have been applied.
Comment 18 Thomas Lendo 2017-06-10 15:55:59 UTC
(In reply to Yousuf Philips (jay) from comment #17)
> (In reply to Thomas Lendo from comment #16)
> > I would suggest so have paragraph and
> > character submenus in the main context menu level instead. People don't care
> > of "styles", they want use paragraph formatting or word formatting or list
> > formatting therefore a "Styles" submenus is not optimal.
> 
> Didnt quite follow this and style users care about styles.
Example:

Other main context menu entries
-----------------------
Edit Paragraph Style
Paragraph Styles >
-----------------------
Character Styles >
Comment 19 Yousuf Philips (jay) 2017-06-11 00:53:43 UTC
Character styles are in.
https://gerrit.libreoffice.org/#/c/38652/

(In reply to Thomas Lendo from comment #18)
> Other main context menu entries
> -----------------------
> Edit Paragraph Style
> Paragraph Styles >
> -----------------------
> Character Styles >

Unfortunately that would clutter the main context menu, especially for users who dont use styles at all, so not an option.
Comment 20 Kumāra 2017-06-12 04:00:49 UTC
(In reply to Yousuf Philips (jay) from comment #10)
> As 'Edit Style' is editing paragraph style, i'd put those together
> 
> -----------------------
> Edit Paragraph Style
> Paragraph Styles      >
> -----------------------
> Character Styles      >

I fully concur as above. ("Edit Styles" is vague for newbies.)
Comment 21 Yousuf Philips (jay) 2017-06-12 19:53:05 UTC
(In reply to Kumāra from comment #20)
> I fully concur as above. ("Edit Styles" is vague for newbies.)

Yes 'Edit Style' will be changed to 'Edit Paragraph Style' based on what happens in other bug 107120.
Comment 22 Cor Nouws 2017-06-13 08:53:41 UTC
(In reply to Thomas Lendo from comment #18)

> 
> Other main context menu entries
> -----------------------
> Edit Paragraph Style
> Paragraph Styles >
> -----------------------
> Character Styles >

I think I do like this idea. There is more then enough room in the context menu. Maybe a bit different order. Fist thought:

Other main context menu entries
-----------------------
Character Styles >
-----------------------
Paragraph Styles >
Edit Paragraph Style
Clear direct formatting
Comment 23 Commit Notification 2017-06-13 13:26:29 UTC
Yousuf Philips committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=41b8cdd0f4130f60027002f1d6daa9f6169b04d9

tdf#85940 Add basic character styles to context menu

It will be available in 6.0.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 24 Commit Notification 2017-06-19 13:56:22 UTC
Xisco Fauli committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=60954fc67a022565741c4ccb4667581a5a790a10

tdf#85940 Use correct reference ID for Quotation

It will be available in 6.0.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 25 Commit Notification 2017-06-19 14:02:10 UTC
Yousuf Philips committed a patch related to this issue.
It has been pushed to "libreoffice-5-4":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=02cea29ce3831d5b72a0d4f71a9de57e38e65d71&h=libreoffice-5-4

tdf#85940 Add basic character styles to context menu

It will be available in 5.4.0.1.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 26 Commit Notification 2017-06-19 14:04:29 UTC
Xisco Fauli committed a patch related to this issue.
It has been pushed to "libreoffice-5-4":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=dc4cacf8beb3224a97693b0ba128a872c6a9a517&h=libreoffice-5-4

tdf#85940 Use correct reference ID for Quotation

It will be available in 5.4.0.1.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 27 Xisco Faulí 2017-07-23 22:34:35 UTC
Polite ping: is this bug fixed? if so, please close it as RESOLVED FIXED